#include "include/common.h"

void monitor_thread_push( struct thread_t *self )
{
	extern struct stat_t	thread_stat;
	struct thread_t		*next;

	self->next = NULL;

	pthread_mutex_lock( &thread_stat.lock );

	if ( thread_stat.first == NULL )
		thread_stat.first = self;
	else
	{
		for ( next = thread_stat.first; next != NULL; next=next->next )
		{
			if ( next->next == NULL )
			{
				next->next = self;
				break;
			}
		}
	}
	thread_stat.count++;
	pthread_mutex_unlock( &thread_stat.lock );
}

void monitor_thread_delete( struct thread_t *self )
{
	extern struct stat_t	thread_stat;
	struct thread_t		*next;

	pthread_mutex_lock( &thread_stat.lock );

	if ( thread_stat.first == self )
		thread_stat.first = NULL;
	else
	{
		for ( next = thread_stat.first; next != NULL; next=next->next )
		{
			if ( next->next == self )
			{
				if ( self->next )
					next->next = self->next;
				else
					next->next = NULL;
				break;
			}
		}
	}
	thread_stat.count--;
	pthread_mutex_unlock( &thread_stat.lock );
}

int monitor_response( struct thread_t *self )
{
	extern struct stat_t	thread_stat;
	struct thread_t		*next;
	time_t			now;

	now = time( &now );

	pthread_mutex_lock( &thread_stat.lock );

	self->response.offset = sprintf( self->response.buf, XML_RESPONSE_OPEN, 0, (long long) 0, thread_stat.count );
	for ( next = thread_stat.first; next != NULL; next=next->next )
	{
		//"<session><process>%d</process><db>%s</db><user>%s</user><status>%s</status><worksql>%s</worksql><since><init>%d</init><idle>%d</idle></since></session>\n"
		self->response.offset += sprintf( &(self->response.buf[self->response.offset]), XML_MONITOR, next->tid, next->request.header.db_name, next->id,
			(next->status == THREAD_INIT?"Initialize":(next->status == THREAD_WAIT?"Client Wainting":"DBMS Working")),
			next->request.data, now-next->time_init, now-next->time_last );
	}
	self->response.offset += sprintf( &(self->response.buf[self->response.offset]), XML_RESPONSE_CLOSE );
	pthread_mutex_unlock( &thread_stat.lock );

	self->response.status = 200;
	self->response.status_msg = "OK";

	return response( self );
}

